routes/web.php
<?php

use App\Http\Controllers\KomenController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\ReplyController;
use App\Http\Controllers\ThreadController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth', 'verified'])->name('dashboard');

Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
    Route::get('/thread/{thread}/edit', [ThreadController::class, 'edit'])->name('thread.edit');
    Route::put('/thread/{thread}', [ThreadController::class, 'update'])->name('thread.update');
    Route::get('/thread/search', [ThreadController::class, 'search'])->name('thread.search');
    Route::delete('/komen/{id}', [KomenController::class, 'destroy'])->name('komen.destroy');
    Route::get('/komen/create/{thread_id}', [KomenController::class, 'create'])->name('komen.create');
    Route::get('/komen/{komen}/edit', [KomenController::class, 'edit'])->name('komen.edit');
    Route::put('/komen/{komen}', [KomenController::class, 'update'])->name('komen.update');
    Route::post('/komen', [KomenController::class, 'store'])->name('komen.store');
    Route::post('/reply', [ReplyController::class, 'store'])->name('reply.store');
    Route::delete('/reply/{id}', [ReplyController::class, 'destroy'])->name('reply.destroy');
    Route::get('/reply/create/{komen_id}', [ReplyController::class, 'create'])->name('reply.create');
    Route::get('/reply/{reply}/edit', [ReplyController::class, 'edit'])->name('reply.edit');
    Route::put('/reply/{reply}', [ReplyController::class, 'update'])->name('reply.update');
    Route::resource('thread', ThreadController::class);
});

require __DIR__ . '/auth.php';

app/Models/Thread.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Thread extends Model
{
    use HasFactory;
    protected $fillable = [
        'judul',
        'isi',
        'likes'
    ];

    public function scopeFilter($query, array $filters)
    {
        if ($filters['search'] ?? false) {
            $query->where('judul', 'like', '%' . request('search') . '%')
                ->orWhere('isi', 'like', '%' . request('search') . '%');
        }
    }

    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }
    public function komen(): HasMany
    {
        return $this->hasMany(Komen::class);
    }
}

app/Http/Controllers/ThreadController.php
<?php

namespace App\Http\Controllers;

use App\Models\Thread;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Redirect;

class ThreadController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        // return view('thread.index', ['threads' => Thread::all()]);
        return view('thread.index', [
            'threads' => Thread::latest()->filter(request(['judul', 'search']))->paginate(6)
        ]);
    }
    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('thread.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        $request->validate([
            'judul' => 'required|string',
            'isi' => 'required|string',
            'lokasi' => 'required|string'
        ]);

        $thread = new Thread;
        $thread->judul = $request->judul;
        $thread->isi = $request->isi;
        $thread->lokasi = $request->lokasi;
        $thread->likes = 0;
        $thread->user_id = auth()->user()->id;
        $thread->save();

        return Redirect::to('/thread');
    }

    /**
     * Display the specified resource.
     * param can be users username or thread id
     */
    public function show($param)
    {
        if (is_numeric($param)) {
            return view('thread.detail', ['thread' => Thread::where('id', $param)->first()]);
        } else {
            try {
                return view('thread.index', ['threads' => User::where('username', $param)->first()->threads()->get()]);
            } catch (\Throwable $th) {
                return view('thread.index', ['threads' => null]);
            }
        }
    }

    /**
     * Show the form for editing the specified resource.
     */

    /**
     * Update the specified resource in storage.
     */
    public function edit(Thread $thread)
    {
        if (auth()->user()->id == $thread->user_id) {
            return view('thread.edit', [
                'thread' => $thread
            ]);
        }
        return redirect()->back()->with('error', 'You\'r not authorized');
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Thread $thread)
    {
        $request->validate([
            'judul' => ['required'],
            'isi' => ['required'],
            'lokasi' => ['required']
        ]);


        $thread->judul = $request->judul;
        $thread->lokasi = $request->lokasi;
        $thread->isi = $request->isi;
        $thread->update();

        return Redirect::to('/thread');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(string $id)
    {
        $thread = Thread::where('id', $id)->first();

        if ($thread->user_id == auth()->user()->id) {
            $thread->delete();
            return redirect('/thread')->with('message', 'Thread berhasil dihapus');
        } else {
            return redirect()->back()->with('error', 'You\'r not authorized');
        }
    }

    public function search(Request $request)
    {
        if ($request->has('search')) {
            $threads = Thread::latest()->filter($request->only('search'))->where('judul', 'LIKE', '%' . $request->query('search') . '%')
                ->orWhere('isi', 'LIKE', '%' . $request->query('search') . '%')->get();
            if ($threads->isEmpty()) {
                return view('thread.index');
            }
            return view('thread.index', ['threads' => $threads]);
        } else {
            return view('thread.index');
        }
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;
use Illuminate\View\View;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     */
    public function render(): View
    {
        return view('layouts.app');
    }
}

resources/views/thread/create.blade.php
<x-app-layout>
    <form class="px-3 py-2" method="post" action="{{ route('thread.store') }}" class="mt-6 space-y-6">
        @csrf

        <div>
            <x-input-label for="name" :value="__('Judul')" />
            <x-text-input id="judul" name="judul" type="text" class="mt-1 block w-full" :value="old('judul')" required
                autofocus autocomplete="judul" />
            <x-input-error class="mt-2" :messages="$errors->get('judul')" />
        </div>

        <div>
            <x-input-label for="lokasi" :value="__('Lokasi')" />
            <x-text-input id="lokasi" name="lokasi" type="text" class="mt-1 block w-full" :value="old('lokasi')"
                required autofocus autocomplete="lokasi" />
            <x-input-error class="mt-2" :messages="$errors->get('lokasi')" />
        </div>

        <div>
            <x-input-label for="isi" :value="__('Isi')" />
            <x-text-input id="isi" name="isi" type="text" class="mt-1 block w-full" :value="old('isi')"
                required autofocus autocomplete="isi" />
            <x-input-error class="mt-2" :messages="$errors->get('isi')" />
        </div>

        <x-primary-button class="mt-2">{{ __('Post') }}</x-primary-button>
        {{-- <div class="flex items-center gap-4">
        <x-primary-button>{{ __('Save') }}</x-primary-button>

        @if (session('status') === 'profile-updated')
            <p x-data="{ show: true }" x-show="show" x-transition x-init="setTimeout(() => show = false, 2000)"
                class="text-sm text-gray-600 dark:text-gray-400">{{ __('Saved.') }}</p>
        @endif
    </div> --}}
    </form>
</x-app-layout>

resources/views/thread/detail.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 dark:text-gray-200 leading-tight">
            {{ __('Threads') }}
        </h2>
    </x-slot>
    <div class="px-4 py-4">
        @if (isset($thread))
            <p>{{ $thread }}</p>
        @else
            <p>data threads masih kosong</p>
        @endif
    </div>
</x-app-layout>

resources/views/thread/edit.blade.php
<x-app-layout>
    <form class="px-3 py-2" method="post" action="/thread/{{ $thread->id }}" class="mt-6 space-y-6">
        @method('PUT')
        @csrf

        <div>
            <x-input-label for="name" :value="__('Judul')" />
            <x-text-input id="judul" name="judul" type="text" class="mt-1 block w-full" value="{{ $thread->judul }}"
                required autofocus autocomplete="judul" />
            <x-input-error class="mt-2" :messages="$errors->get('judul')" />
        </div>

        <div>
            <x-input-label for="lokasi" :value="__('Lokasi')" />
            <x-text-input id="lokasi" name="lokasi" type="text" class="mt-1 block w-full"
                value="{{ $thread->lokasi }}" required autofocus autocomplete="judul" />
            <x-input-error class="mt-2" :messages="$errors->get('lokasi')" />
        </div>

        <div>
            <x-input-label for="isi" :value="__('Isi')" />
            <x-text-input id="isi" name="isi" type="text" class="mt-1 block w-full"
                value="{{ $thread->isi }}" required autofocus autocomplete="isi" />
            <x-input-error class="mt-2" :messages="$errors->get('isi')" />
        </div>


        <x-primary-button class="mt-2">{{ __('Edit') }}</x-primary-button>
        {{-- <div class="flex items-center gap-4">
        <x-primary-button>{{ __('Save') }}</x-primary-button>

        @if (session('status') === 'profile-updated')
            <p x-data="{ show: true }" x-show="show" x-transition x-init="setTimeout(() => show = false, 2000)"
                class="text-sm text-gray-600 dark:text-gray-400">{{ __('Saved.') }}</p>
        @endif
    </div> --}}
    </form>
</x-app-layout>

resources/views/thread/index.blade.php
@section('tittle', 'Thread')


<x-app-layout>
    {{-- @include('partials._search') --}}

    <div class="px-4 py-4">
        @if (isset($threads))
            @foreach ($threads as $thread)
                {{-- postingan --}}
                <div class="container my-3 mx-auto  w-500 rounded-md px-5 py-5 bg-white ">

                    {{-- <h1>{{ auth()->user()->id }}</h1> --}}
                    {{-- bagian nama --}}
                    <p class=" text-lg pb-2">
                        <span class="text-xl font-bold">{{ $thread->user->username }}</span>

                        {{-- waktu postingan --}}
                        <span class="ps-1 text-slate-400">{{ substr($thread->user->updated_at, 0, 10) }}</span>
                    </p>
                    {{-- end of bagian nama --}}

                    {{-- images --}}
                    <img class="" src="{{ asset('assets/postingan1.svg') }}" alt="Gambar Thread">
                    {{-- end of images --}}

                    {{-- konten thread --}}
                    <div class=" py-4">
                        <div class="font-bold text-xl mb-0">{{ $thread->judul }}</div>
                        <div class="font-thin text-xs mt-0 mb-2 text-slate-400">{{ $thread->lokasi }}</div>

                        <p class="text-gray-700 text-base">{{ $thread->isi }}</p>
                    </div>
                    {{-- end of konten thread --}}

                    <div class=" py-4 flex justify-normal ">


                        {{-- button comment --}}


                        <div x-data="{ showText: false }" class="  ">
                            <button @click="showText = !showText"
                                class="bg-red-500 hover:bg-red-700 text-white font-bold py-2 px-4 rounded-full ">
                                <span>
                                    <img src="{{ asset('assets/iconComment.svg') }}" alt=""
                                        class="inline-block align-middle mr-2">
                                    comment
                                </span>
                            </button>

                            {{-- comment --}}
                            <div x-show="showText" class="text-black">
                                @foreach ($thread->komen as $komen)
                                    <div class="container my-1 px-2  rounded-md bg-slate-200 py-2 w-300">
                                        <h1 class=" font-bold">{{ $komen->user->username }} </h1>

                                        <p>{{ $komen->isi }}</p>
                                        <div class="flex flex-row space-x-3">
                                            <form action="{{ route('komen.destroy', $komen->id) }}" method="POST">
                                                @csrf
                                                @method('DELETE')

                                                @if ($komen->user_id == auth()->user()->id)
                                                    <button class="text-red-500">
                                                        <i class="fa-solid fa-trash"></i>
                                                        Delete Comment
                                                    </button>
                                                @endif
                                            </form>

                                            @if ($komen->user_id == auth()->user()->id)
                                                <form action="{{ route('komen.edit', $komen->id) }}" method="GET">
                                                    <button class="text-blue-500"><i
                                                            class="fa-solid fa-trash"></i>Edit</button>
                                                </form>
                                            @endif
                                            <form action="{{ route('reply.create', $komen->id) }}" method="GET">
                                                <button class="text-blue-500"><i
                                                        class="fa-solid fa-trash"></i>Reply</button>
                                            </form>
                                        </div>

                                        {{-- reply --}}
                                        <button class="text-blue-500 my-2 px-2 ps-5"
                                            onclick="toggleReply('{{ $komen->id }}')">show reply</button>
                                        <section id="{{ $komen->id }}" style="display: none;">
                                            @foreach ($komen->reply as $reply)
                                                {{-- button reply --}}

                                                {{-- balasan --}}
                                                <div id="reply-{{ $reply->id }}" class="bg-gray-200 reply-item">
                                                    <div class="container my-1 px-2 rounded-md  ms-5">
                                                        <p class="font-bold">{{ $reply->user->username }}</p>
                                                        <p>{{ $reply->isi }}</p>
                                                        <div class="flex flex-row space-x-3">
                                                            @if ($reply->user_id == auth()->user()->id)
                                                                <form action="{{ route('reply.destroy', $reply->id) }}"
                                                                    method="POST">
                                                                    @csrf
                                                                    @method('DELETE')
                                                                    <button class="text-blue-500"><i
                                                                            class="fa-solid fa-trash"></i>Delete
                                                                        Reply</button>
                                                                </form>

                                                                <form action="{{ route('reply.edit', $reply->id) }}"
                                                                    method="GET">
                                                                    <button class="text-blue-500"><i
                                                                            class="fa-solid fa-trash"></i>Edit</button>
                                                                </form>
                                                            @endif
                                                        </div>
                                                    </div>
                                                </div>
                                            @endforeach
                                        </section>

                                        <script>
                                            function toggleReply(id) {
                                                var section = document.getElementById(id);
                                                if (section.style.display === "none") {
                                                    section.style.display = "block";
                                                } else {
                                                    section.style.display = "none";
                                                }
                                            }
                                        </script>

                                        {{-- end of reply --}}

                                        {{-- end of reply --}}

                                        {{-- tambahkan komen --}}


                                    </div>
                                @endforeach
                                {{-- komen inputan --}}
                                {{-- <form class="px-3 py-2" method="post" action="{{ route('komen.store') }}"
                                    class="mt-6 space-y-6">
                                    @csrf

                                    <div>
                                        <x-input-label for="isi" :value="__('Isi')" />
                                        <x-text-input id="isi" name="isi" type="text"
                                            class="mt-1 block w-full" required autofocus />
                                        <x-input-error class="mt-2" :messages="$errors->get('isi')" />
                                        <x-text-input id="isi" name="thread_id" type="hidden"
                                            class="mt-1 block w-full" value="{{ $thread_id }}" required autofocus />
                                        <x-input-error class="mt-2" :messages="$errors->get('thread_id')" />
                                    </div>

                                    <x-primary-button class="mt-2">{{ __('Post') }}</x-primary-button>
                                </form> --}}
                                {{-- end of komen inputan --}}
                                <form action="{{ route('komen.create', ['thread_id' => $thread->id]) }}"
                                    method="GET">
                                    <button class="text-blue-500"><i class="fa-solid fa-trash "></i> Add
                                        Comment</button>
                                </form>
                            </div>

                        </div>
                        {{-- end comment --}}




                        {{-- end ofbutton comment --}}

                    </div>

                    {{-- @foreach ($thread->komen as $komen)
                    @endforeach --}}
                    @if ($thread->user_id == auth()->user()->id)
                        <div class="flex flex-row space-x-3 ">
                            <form action="{{ route('thread.destroy', $thread->id) }}" method="POST">
                                @csrf
                                @method('DELETE')
                                <button class="text-blue-500"><i class="fa-solid fa-trash"></i>Delete Thread</button>
                            </form>

                            <form action="{{ route('thread.edit', $thread->id) }}" method="GET">
                                <button class="text-blue-500"><i class="fa-solid fa-trash"></i>Edit</button>
                            </form>
                            {{-- <form action="{{ route('komen.create', ['thread_id' => $thread->id]) }}" method="GET">
                                <button class="text-blue-500"><i class="fa-solid fa-trash"></i>Comment</button>
                            </form> --}}
                        </div>
                    @endif
                </div>
                {{-- end of postingan --}}
            @endforeach
        @else
            <p>data threads masih kosong</p>

        @endif
    </div>

</x-app-layout>
{{-- <script>
    function toggleReply(id) {
        const replyDivs = document.getElementById(id);
        console.log(id);
        replyDivs.classList.toggle('hidden');
    }
</script> --}}